Loading...
Searching...
No Matches
Opm::Satfunc::PhaseChecks::UnscaledSatfuncCheckPoint< Scalar > Class Template Reference

Callbacks for defining the consistency check point of a single region. More...

`#include <UnscaledSatfuncCheckPoint.hpp>`

Inheritance diagram for Opm::Satfunc::PhaseChecks::UnscaledSatfuncCheckPoint< Scalar >:

## Classes

struct | UnscaledEndPoints
| Collection of saturation function end-points and function values extracted from tabulated saturation functions. More...

## Public Member Functions

| UnscaledSatfuncCheckPoint (const std::vector< int > *region, const int regIdxOffset, const UnscaledEndPoints &unscaledEndPoints)
| Constructor.
std::optional< std::size_t > | pointID (const int cellIdx) const override
| Compute locally unique, i.e., per MPI rank, ID of this check for a particular cell index.
void | populateCheckPoint (const int cellIdx, EclEpsScalingPointsInfo< Scalar > &endPoints) const override
| Populate check point values for a particular cell.
Public Member Functions inherited from Opm::Satfunc::PhaseChecks::SatfuncCheckPointInterface< Scalar >
virtual | ~SatfuncCheckPointInterface ()=default
| Virtual destructor for public inheritance.

## Detailed Description

template<typename Scalar>
class Opm::Satfunc::PhaseChecks::UnscaledSatfuncCheckPoint< Scalar >

Callbacks for defining the consistency check point of a single region.

Template Parameters

  Scalar | Element type. Typically `float` or `double`.

## Constructor & Destructor Documentation

## UnscaledSatfuncCheckPoint()

template<typename Scalar>

Opm::Satfunc::PhaseChecks::UnscaledSatfuncCheckPoint< Scalar >::UnscaledSatfuncCheckPoint | ( | const std::vector< int > * | region,
|  | const int | regIdxOffset,
|  | const UnscaledEndPoints & | unscaledEndPoints )

inline explicit

Constructor.

Parameters

  [in] | region | Region index for each active cell on rank.
  [in] | regIdxOffset | Region index offset. Pass one (1) if `region` contains one-based region indices.
  [in] | unscaledEndPoints | Saturation function end-points for all tabulated saturation functions. Lifetime of members must exceed the `UnscaledSatfuncCheckPoint` object.

## Member Function Documentation

## pointID()

template<typename Scalar>

std::optional< std::size_t > Opm::Satfunc::PhaseChecks::UnscaledSatfuncCheckPoint< Scalar >::pointID | ( | const int | cellIdx | ) | const

override virtual

Compute locally unique, i.e., per MPI rank, ID of this check for a particular cell index.

Common examples include the drainage or imbibition region ID (i.e., SATNUM or IMBNUM) or the Cartesian block index of a cell.

Parameters

  [in] | cellIdx | Active cell index on current rank.

Returns
  Locally unique point ID for `cellIdx`. Nullopt if this check point does not apply to `cellIdx`. Typically because the underlying region of `cellIdx` has already been visited.

Implements Opm::Satfunc::PhaseChecks::SatfuncCheckPointInterface< Scalar >.

## populateCheckPoint()

template<typename Scalar>

void Opm::Satfunc::PhaseChecks::UnscaledSatfuncCheckPoint< Scalar >::populateCheckPoint | ( | const int | cellIdx,
|  | EclEpsScalingPointsInfo< Scalar > & | endPoints ) const

override virtual

Populate check point values for a particular cell.

Parameters

  [in] | cellIdx | Active cell index on current rank.
  [out] | endPoints | Set of saturation function end-points.

Implements Opm::Satfunc::PhaseChecks::SatfuncCheckPointInterface< Scalar >.

The documentation for this class was generated from the following files:

- opm/simulators/utils/satfunc/SatfuncConsistencyCheckManager.hpp
- opm/simulators/utils/satfunc/UnscaledSatfuncCheckPoint.hpp
- opm/simulators/utils/satfunc/UnscaledSatfuncCheckPoint.cpp